import 'package:doctor_app_flutter/core/model/patient/patiant_info_model.dart';
import 'package:doctor_app_flutter/core/viewModel/SOAP_view_model.dart';
import 'package:doctor_app_flutter/routes.dart';
import 'package:doctor_app_flutter/screens/base/base_view.dart';
import 'package:doctor_app_flutter/utils/translations_delegate_base_utils.dart';
import 'package:doctor_app_flutter/widgets/patients/profile/PatientProfileButton.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class ProfileMedicalInfoWidget extends StatelessWidget {
  final String? from;
  final String? to;
  final PatiantInformtion? patient;
  final String? patientType;
  final String? arrivalType;
  final bool isInpatient;

  ProfileMedicalInfoWidget({Key? key, this.patient, this.patientType, this.arrivalType, this.from, this.to, this.isInpatient = false});

  @override
  Widget build(BuildContext context) {
    return BaseView<SOAPViewModel>(
      onModelReady: (model) async {},
      builder: (_, model, w) => GridView.count(
        shrinkWrap: true,
        physics: NeverScrollableScrollPhysics(),
        crossAxisSpacing: 10,
        mainAxisSpacing: 10,
        childAspectRatio: 1 / 1.0,
        crossAxisCount: 3,
        children: [
          PatientProfileButton(
            key: key,
            patient: patient,
            patientType: patientType,
            arrivalType: arrivalType,
            from: from,
            to: to,
            nameLine1: TranslationBase.of(context).vital,
            nameLine2: TranslationBase.of(context).signs,
            route: VITAL_SIGN_DETAILS,
            icon: 'assets/images/svgs/profile_screen/vital signs.svg',
            onTap: () {},
          ),
          // if (selectedPatientType != 7)
          PatientProfileButton(
            key: key,
            patient: patient,
            patientType: patientType,
            arrivalType: arrivalType,
            route: HEALTH_SUMMARY,
            nameLine1: "Health",
            //TranslationBase.of(context).medicalReport,
            nameLine2: "Summary",
            //TranslationBase.of(context).summaryReport,
            icon: 'assets/images/svgs/profile_screen/health summary.svg', onTap: () {},
          ),
          PatientProfileButton(
            key: key,
            patient: patient,
            patientType: patientType,
            arrivalType: arrivalType,
            route: LAB_RESULT,
            nameLine1: TranslationBase.of(context).lab,
            nameLine2: TranslationBase.of(context).result,
            icon: 'assets/images/svgs/profile_screen/lab results.svg',
            onTap: () {},
          ),
          PatientProfileButton(
            key: key,
            patient: patient,
            patientType: patientType,
            arrivalType: arrivalType,
            route: ALL_SPECIAL_LAB_RESULT,
            nameLine1: TranslationBase.of(context).lab,
            nameLine2: TranslationBase.of(context).special,
            icon: 'assets/images/svgs/profile_screen/lab results.svg',
            onTap: () {},
          ),
          // if (int.parse(patientType) == 7 || int.parse(patientType) == 6)
          PatientProfileButton(
            key: key,
            patient: patient,
            patientType: patientType,
            arrivalType: arrivalType,
            isInPatient: isInpatient!,
            route: RADIOLOGY_PATIENT,
            nameLine1: TranslationBase.of(context).radiology,
            nameLine2: TranslationBase.of(context).service,
            icon: 'assets/images/svgs/profile_screen/health summary.svg',
            onTap: () {},
          ),
          PatientProfileButton(
            key: key,
            patient: patient,
            patientType: patientType,
            arrivalType: arrivalType,
            route: PATIENT_ECG,
            nameLine1: TranslationBase.of(context).patient,
            nameLine2: "ECG",
            icon: 'assets/images/svgs/profile_screen/ECG.svg',
            onTap: () {},
          ),
          PatientProfileButton(
            key: key,
            patient: patient,
            patientType: patientType,
            arrivalType: arrivalType,
            route: ORDER_PRESCRIPTION_OLD,
            nameLine1: TranslationBase.of(context).orders,
            nameLine2: TranslationBase.of(context).prescription,
            icon: 'assets/images/svgs/profile_screen/order prescription.svg',
            onTap: () {},
          ),
          // if (int.parse(patientType) == 7 || int.parse(patientType) == 6)
          PatientProfileButton(
            key: key,
            patient: patient,
            patientType: patientType,
            arrivalType: arrivalType,
            route: ORDER_PROCEDURE,
            nameLine1: TranslationBase.of(context).orders,
            nameLine2: TranslationBase.of(context).procedures,
            icon: 'assets/images/svgs/profile_screen/Order Procedures.svg',
            onTap: () {},
          ),
          //if (int.parse(patientType) == 7 || int.parse(patientType) == 6)
          PatientProfileButton(
            key: key,
            patient: patient,
            patientType: patientType,
            arrivalType: arrivalType,
            route: PATIENT_INSURANCE_APPROVALS_NEW,
            nameLine1: TranslationBase.of(context).insurance,
            nameLine2: TranslationBase.of(context).service,
            icon: 'assets/images/svgs/profile_screen/insurance approval.svg',
            onTap: () {},
          ),
          // if (int.parse(patientType) == 7 || int.parse(patientType) == 6)
          PatientProfileButton(
            key: key,
            patient: patient,
            patientType: patientType,
            arrivalType: arrivalType,
            route: ADD_SICKLEAVE,
            nameLine1: TranslationBase.of(context).patientSick,
            nameLine2: TranslationBase.of(context).leave,
            icon: 'assets/images/svgs/profile_screen/patient sick leave.svg',
            onTap: () {},
          ),
          if (patient!.appointmentNo != null && patient!.appointmentNo != 0)
            PatientProfileButton(
              key: key,
              patient: patient,
              patientType: patientType,
              arrivalType: arrivalType,
              route: PATIENT_UCAF_REQUEST,
              isDisable: patient!.patientStatusType != 43 ? true : false,
              nameLine1: TranslationBase.of(context).patient,
              nameLine2: TranslationBase.of(context).ucaf,
              icon: 'patient/ucaf.png',
              onTap: () {},
            ),
          if (patient!.appointmentNo != null && patient!.appointmentNo != 0)
            PatientProfileButton(
              key: key,
              patient: patient,
              patientType: patientType,
              arrivalType: arrivalType,
              route: REFER_PATIENT_TO_DOCTOR,
              isDisable: patient!.patientStatusType != 43 ? true : false,
              nameLine1: TranslationBase.of(context).referral,
              nameLine2: TranslationBase.of(context).patient,
              icon: 'patient/refer_patient.png',
              onTap: () {},
            ),
          if (patient!.appointmentNo != null && patient!.appointmentNo != 0)
            PatientProfileButton(
              key: key,
              patient: patient,
              patientType: patientType,
              arrivalType: arrivalType,
              route: PATIENT_ADMISSION_REQUEST,
              isDisable: patient!.patientStatusType != 43 ? true : false,
              nameLine1: TranslationBase.of(context).admission,
              nameLine2: TranslationBase.of(context).request,
              icon: 'patient/admission_req.png',
              onTap: () {},
            ),
          if (isInpatient)
            PatientProfileButton(
              key: key,
              patient: patient,
              patientType: patientType,
              arrivalType: arrivalType,
              route: PROGRESS_NOTE,
              nameLine1: TranslationBase.of(context).progress,
              nameLine2: TranslationBase.of(context).note,
              icon: 'assets/images/svgs/profile_screen/Progress notes.svg',
              onTap: () {},
            ),
          if (isInpatient)
            PatientProfileButton(
              key: key,
              patient: patient,
              patientType: patientType,
              arrivalType: arrivalType,
              route: ORDER_NOTE,
              nameLine1: "Order",
              //"Text",
              nameLine2: "Sheet",
              icon: 'assets/images/svgs/profile_screen/Progress notes.svg', onTap: () {},
            ),
        ],
      ),
    );
  }
}
